<?php

require APPPATH . 'libraries/RestController.php';

use App\RestServer\RestController;

class StoreFrontAPIController extends RestController
{
    public function __construct()
    {
            parent::__construct();

            // Set timezone to Philippines
            date_default_timezone_set('Asia/Manila');
    }

    public function index_get() {
        // Fetch data logic here
        $data = ['message' => 'GET request received'];
        $this->response($data, 200);
    }

    public function itemModel_get($modelno) {
        
        $this->load->model("Items");
        $this->load->model("BranchItemLedger");

        $result = $this->Items->getItemInfoByModelNo('DB-422');
        
        // disabled during testing
        //$result = $this->Items->getItemInfoByModelNo($modelno);

        $itemcount = $result->num_rows();
        
        if($itemcount > 0)
        {
            $branches = [];
            $row = $result->row();

            $resultBranches = $this->BranchItemLedger->getDataByItemcodeWithBranchExcempt($row->itemcode);

            foreach($resultBranches->result() as $rowBranches )
            {
                $branches[] = [
                    'itemcode' => $rowBranches->itemcode,
                    'brCode' => $rowBranches->brCode,
                    'endingqty' => $rowBranches->endingqty
                ];
            }

            $item = [
                'itemcode' => $row->itemcode,
                'modelno' => $row->modelno,
                'seriescode' => $row->seriescode,
                'item_desc' => $row->item_desc,
                'karat' => $row->karat,
                'size' => $row->size,
                'grams' => $row->grams,
                'cts' => $row->cts,
                'srp' => $row->srp,
                'catCode' => $row->catCode,
                'goldID' => $row->goldID,
                'supCode' => $row->supCode,
                'modifieddate' => $row->modifieddate,
                'branches' => $branches
            ];

            $data = ['status' => 'FOUND', 
                     'item_count' => $itemcount,
                     'data' => $item];
        }
        else
            $data = ['status' => 'NOTFOUND', 
                     'item_count' => 0,
                     'data' => null];
        
        $this->response($data, 200);
    }
}